<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :ok-text="isNew ? 'Создать' : 'Изменить'"
    @submit="onSaveForm"
    class="group-form"
  >
    <div class="group-form__row">
      <ob-input
        label="Имя группы"
        v-model="formData.title"
        property="title"
        :is-valid="dataSource.isTitleValid ? null : false"
        validation-message="Группа с таким названием уже существует в системе"
        @input="onInputTitle"
      />
    </div>

    <div class="group-form__row">
      <ob-input
        label="Описание (необязательно)"
        v-model="formData.description"
        property="title"
      />
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";

  export default {
    name: 'groupModal',
    
    components: {
      ObForm,
      ObInput,
    },

    mixins: [FormValidationMixin],

    data() {
      return {
        errors: {
          groupExist: true
        },
      }
    },

    computed: {
      formModel() {
        return {
          uuid: {
            value: ''
          },
          title: {
            value: ''
          },
          description: {
            value: ''
          }
        }
      },

      isNew () {
        return this.dataSource && !this.dataSource.uuid
      },
      isGroupExist () {
        if (!this.errors.groupExist) return null

        return false
      },
    },

    methods: {
      onInputTitle () {
        if (this.errors.groupExist) {
          this.errors.groupExist = false
        }
      },

      async onSaveForm (data) {
        this.clearError()
        await this.isNew ? this.addGroup(data) : this.updateGroup(data)
      },

      async addGroup (data) {
        try {
          this.$emit('submitted', data);
        } catch ({ err }) {
          console.error(err)
        }
      },

      async updateGroup (data) {
        this.$emit('submitted', data);
      },

      clearError () {
        this.errors = {
          groupExist: false
        }
      },
    }
  }
</script>

<style lang="scss" scoped>
  .group-form__row:not(:last-child) {
    margin-bottom: 20px;
  }
</style>